﻿'---------------------------------------------------------------------------------
'VCP Port
'--------------------------------------------------------------------------------
Imports System
Imports System.IO.Ports 'Serial Port Objects
Imports System.Text     'Import for Serial Components
Public Class MainForm

    Inherits System.Windows.Forms.Form
    '------------------------------------------------
    'Define  Application Com PORT
    '------------------------------------------------
    Friend ComPort As New SerialPort("Com5", 9600, Parity.None, 8, StopBits.One)
    Dim ascii As New System.Text.ASCIIEncoding
    '--------------------------------------------------------------
    'Transmit and Receive Buffers
    '--------------------------------------------------------------
    Public ReceiveDataBuffer(6) As Byte
    Public DataWriteBuffer(2) As Byte
    '--------------------------------------------------------------
    ' Public Variables
    '--------------------------------------------------------------
    Public Adc_Raw As Integer

    '------------------------------------------------------------------
    ' On Start up configure the comport and other Application Specifics
    '------------------------------------------------------------------
    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles MyBase.Load
        Try
            If (Not ComPort.IsOpen) Then
                ComPort.Encoding = ascii
                ComPort.WriteTimeout = 300
                ComPort.ReadTimeout = 300
                ComPort.ReceivedBytesThreshold = 2
                ComPort.Open()
            Else

            End If
        Catch ex As Exception
            MessageBox.Show("No Comport Found")
        End Try
    End Sub

    '---------------------------------------------------------
    'Release the Comport on Application Closing
    '---------------------------------------------------------
    Private Sub MainForm_FormClosing(ByVal sender As System.Object, _
    ByVal e As System.Windows.Forms.FormClosingEventArgs) _
    Handles MyBase.FormClosing
        If ComPort.IsOpen Then
            ComPort.Close()
        End If
    End Sub
    '---------------------------------------------------------------------------------------------
    ' Start Application on Button Click
    '---------------------------------------------------------------------------------------------
    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                    Handles btnRun.Click
        Timer.Enabled = True ' Start Com Timer 

    End Sub
    '----------------------------------------------------------------------------------------------
    'Timer Tick event
    '----------------------------------------------------------------------------------------------
    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                   Handles Timer.Tick
        Dim Read As Byte
        DataWriteBuffer(0) = &H53
        ComPort.Write(DataWriteBuffer, 0, 1)
        Read = ComPort.Read(ReceiveDataBuffer, 0, 2)
        Call Process()
    End Sub

    '------------------------------------------------------------------------------------------------------------
    'Close the application on Button click
    '------------------------------------------------------------------------------------------------------------
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Timer.Enabled = False
        Me.Close()
    End Sub
    '-------------------------------------------------------------------------------------------------------------
    ' Process the data
    '------------------------------------------------------------------------------------------------------------
    Private Sub Process()
        Adc_Raw = ((ReceiveDataBuffer(0) * 256) + ReceiveDataBuffer(1))
        txbADC.Text = CStr(Adc_Raw)
    End Sub
End Class
